# frozen_string_literal: true

require 'apiphobic/parameters/include'

module  Apiphobic
module  Resource
module  Processors
class   Including
  attr_accessor :resource,
                :parameters

  # rubocop:disable Style/OptionHash
  def initialize(resource, parameters = {})
    self.resource   = resource
    self.parameters = Parameters::Include.new(parameters['include'])
  end
  # rubocop:enable Style/OptionHash

  def self.processed(*attrs)
    new(*attrs).processed
  end

  def self.meta(*_attrs)
    {}
  end

  def processed
    return resource unless parameters.present?

    resource.includes(*parameters.to_a)
  end

  def meta
    {}
  end
end
end
end
end
